function [cx,cy,cc] = lineartri_debug(p,q,r,a,b,c)
%LINEAR_ON_TRI  return coefficients of a linear fcn on a triangle
%  the function has value a at p, b at q and c at r
%  
  debugplot = 0;
  
  
  a1 = q(2) - r(2);
  b1 = -q(1) + r(1);
  c1 = -a1*r(1) - b1*r(2);
  d1 = 1./(a1*p(1) + b1*p(2) + c1);
  a1 = d1*a1;  b1 = d1*b1;  c1 = d1*c1;

  
  a2 = r(2) - p(2);
  b2 = -r(1) + p(1);
  c2 = -a2*r(1) - b2*r(2);
  d2 = 1./(a2*q(1) + b2*q(2) + c2);
  a2 = d2*a2;  b2 = d2*b2;  c2 = d2*c2;
  
  a3 = p(2) - q(2);
  b3 = -p(1) + q(1);
  c3 = -a3*p(1) - b3*p(2);
  d3 = 1./(a3*r(1) + b3*r(2) + c3);
  a3 = d3*a3;  b3 = d3*b3;  c3 = d3*c3;

  cx = a*a1 + b*a2 + c*a3;
  cy = a*b1 + b*b2 + c*b3;
  cc = a*c1 + b*c2 + c*c3;

  if (debugplot)
    t = (p+q+r)/3;
    t1 = t(1);
    t2 = t(2);
    if(a1*t1 + b1*t2 + c1 > 0)
      ineq1 = 1;
    else
      ineq1 = -1;
    end
    if(a2*t1 + b2*t2 + c2 > 0)
      ineq2 = 1;
    else
      ineq2 = -1;
    end
    if(a3*t1 + b3*t2 + c3 > 0)
      ineq3 = 1;
    else
      ineq3 = -1;
    end

    ymin = min([p(2),q(2),r(2)]);
    ymax = max([p(2),q(2),r(2)]);
    xmin = min([p(1),q(1),r(1)]);
    xmax = max([p(1),q(1),r(1)]);
  
    dx = (xmax-xmin)/50
    dy = (ymax-ymin)/50
    [xx,yy] = meshgrid(xmin:dx:xmax, ymin:dy:ymax);
  
    z = (cx*xx + cy*yy + cc) .* ...
	(ineq1*(a1*xx + b1*yy + c1) >= 0 & ...
	 ineq2*(a2*xx + b2*yy + c2) >= 0 & ...
	 ineq3*(a3*xx + b3*yy + c3) >= 0);
    
    figure(97); clf;
    surf(xx,yy,z);
    hold on;
    plot3(p(1),p(2),0,'b*', p(1),p(2),0,'ko');
    plot3(p(1),p(2),a,'r*', p(1),p(2),a,'ko');
    plot3(q(1),q(2),0,'b*', q(1),q(2),0,'ko');
    plot3(q(1),q(2),b,'r*', q(1),q(2),b,'ko');
    plot3(r(1),r(2),0,'b*', r(1),r(2),0,'ko');
    plot3(r(1),r(2),c,'r*', r(1),r(2),c,'ko');
    axis([xmin xmax ymin ymax])
  end
